
set ac          /sec1,sec2,lab,hh,total/;
set i(ac)        /sec1,sec2,lab,hh/;

alias (ac,acp);
alias (i,j);

table sam(*,*)
        sec1   sec2   lab   hh    total
sec1    52     45           150   247
sec2    95     48           90    233
lab     120    89                 209
hh                    192         192
total   267    182    192   240
;

parameters
    Q0(i,j)    initial value of SAM
    H0         sum of all transaction flows ;

*Assignment for parameters
    Q0(i,j)=sam(i,j);
    H0=sum((i,j),sam(i,j));

display H0,sam;

Variables
    Q(i,j)       the target values of SAM
    H            the adjust sum of all transaction flows(total)
    Hratio       the ratio of Initial and adjusted total
    z            Expected entropy value;

*nonneg           values must be non-negative
Positive variable Q(i,j);

equations
    totalsum         adjusted total
    directentropy    objective function
    balance          Balancing restrictions for each account
    Hratiodef        the ratio of Initial and adjusted total;

    totalsum..       H =e= sum((i,j),Q(i,j));
    Hratiodef..      Hratio =e= H/H0;
    directentropy..  z=e=sum((i,j)$sam(i,j),Q(i,j)*log(Q(i,j)/sam(i,j)))/H-log(Hratio);
    balance(i)..     sum(j$sam(i,j),Q(i,j)) =e= sum(j,Q(j,i));


*Assign values to the initial values of variables.
*There are special limitations on the scope of Hratio here. Because without limitation, when the objective function is minimized,
*H will tend towards infinity, and the true result cannot be obtained
    Q.l(i,j)=Q0(i,j);
    H.l=H0;
    Hratio.lo=0.5;
    Hratio.up=2.0;
    H.lo = H0*Hratio.lo;
    H.up = H0*Hratio.up;

model sambal  /all/;
solve sambal using dnlp minimizing z;


display Q.l,z.l,H.l,H0,Hratio.l;
*end
